--version 1.2.0
local Slots = {
	"Head","Neck","Shoulder","Back","Chest","Wrist",
	"Hands","Waist","Legs","Feet","Finger0","Finger1",
	"Trinket0","Trinket1", "MainHand", "SecondaryHand"
}

print("Debug: "..tostring(KamiUIDebugStatus));


local InspectCache = {}

local ILvlFrame = CreateFrame("Frame", "IlvlFrame")
local lastInspectReady
local inspecting = false
local InspectGUID

ILvlFrame:RegisterEvent("INSPECT_READY")
ILvlFrame:RegisterEvent("PLAYER_TARGET_CHANGED")

ILvlFrame:ClearAllPoints()
ILvlFrame:SetHeight(300)
ILvlFrame:SetWidth(1000)
ILvlFrame.text = ILvlFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont")
ILvlFrame.text:SetAllPoints()
ILvlFrame.text:SetTextHeight(13)
ILvlFrame:SetAlpha(1)

ILvlFrame:SetScript("OnEvent", function(self, event_name, ...)
	if self[event_name] then
		return self[event_name](self, event_name, ...)
	end
end)

function ILvlFrame:INSPECT_READY(event, GUID)	
	ILvlFrame.text:SetText(format("ilvl: ??"))
	lastInspectReady = GetTime()
	InspectGUID = GUID
	inspecting = true
	--KamiUI.KamiLog("Inspecting")
end

function ILvlFrame:intializeItemLevelInspection()

	if InspectFrame and InspectFrame.unit then 
		KamiUI.KamiLog("--------------");
		KamiUI.KamiLog("Start Scanning");
		KamiUI.KamiLog("--------------");
		local UnitIlevel = 0
		if not InspectCache[InspectGUID] or InspectCache[InspectGUID].time > 800 then
			UnitIlevel = self:GetItemLvL(InspectFrame.unit)
			InspectCache[InspectGUID] = {time = GetTime()}
			InspectCache[InspectGUID].ilevel = UnitIlevel
		else
			UnitIlevel = InspectCache[InspectGUID].ilevel
		end
		if InspectFrame and InspectFrame.unit then
			ILvlFrame:SetParent(InspectFrame)
			ILvlFrame:SetPoint("BOTTOM", InspectFrame, "RIGHT", -45, 15)
			
			ILvlFrame.text:SetText(format("ilvl: ".. tostring(UnitIlevel)))
			
		end
		KamiUI.KamiLog("--------------");
		KamiUI.KamiLog("Done Scanning");
		KamiUI.KamiLog("--------------");
	end
end

function ILvlFrame:PLAYER_TARGET_CHANGED()
	isCalculatingIlevel = false;
end

function ILvlFrame:GetItemLvL(unit)
	local total, item = 0, 0;
	local ilvlstring = "";
	local artifactIlvl = nil
	local artifactItemLink = nil
	for i = 1, #Slots do
		local itemLink = GetInventoryItemLink(unit, GetInventorySlotInfo(("%sSlot"):format(Slots[i])));
		--KamiUI.KamiLog("Scanning Slot: "..Slots[i]);
		if (itemLink ~= nil) then
			local itemLevel = self:ScanForItemLevel(itemLink);
			local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4,
    Suffix, Unique, LinkLvl, Name = string.find(itemLink,
    "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
    		
			if(itemLevel and itemLevel > 0) then
				item = item + 1;
				total = total + itemLevel;
				if (Color ==  "e6cc80")then
					artifactItemLink = itemLink
					if (artifactIlvl == nil or artifactIlvl <= itemLevel)then
						total = total - itemLevel
						itemLevel = self:ScanForItemLevel(itemLink);
						KamiUI.KamiLog(itemLink)
						if(itemLevel and itemLevel > 0 and (artifactIlvl == nil or artifactIlvl < itemLevel)) then
							total = total + itemLevel;
							artifactIlvl = itemLevel;
						end
					end
					if (Slots[i] == "SecondaryHand" and artifactIlvl ~= nil and artifactIlvl > itemLevel)then
						item = item - 1
						total = total - itemLevel;
					end
					KamiUI.KamiLog(tostring(artifactIlvl))
				end
				--KamiUI.KamiLog(Color)
			end
			ilvlstring = ilvlstring.." + "..itemLevel
			--KamiUI.KamiLog("Scanning item: "..itemLink .. "ilvl: "..itemLevel .. " "..Color);
		else
			ilvlstring = ilvlstring.." + "..0
			--KamiUI.KamiLog("Scanning Slot: "..Slots[i] .. "is Empty");
		end
	end
	if (artifactIlvl ==750)then
		total = total - artifactIlvl
		artifactIlvl = self:ScanForItemLevel(artifactItemLink);
		total = total + artifactIlvl;
	end
	if(total < 1) then
		return
	end
	KamiUI.KamiLog(ilvlstring .. " = " ..tostring(floor(total / item)).. tostring(item));
	return floor(total / item)
end

function IlvlFrame:GetAvailableTooltip()
	for i=1, #GameTooltip.shoppingTooltips do
		if(not GameTooltip.shoppingTooltips[i]:IsShown()) then
			return GameTooltip.shoppingTooltips[i]
		end
	end
end

--randomly some items dont give the correct ItemLevel a second inspectiong seems to give the correct value
function ILvlFrame:ScanForItemLevel(itemLink)
	local tt = self:GetAvailableTooltip();
	tt:SetOwner(UIParent, "ANCHOR_NONE");
	tt:SetHyperlink(itemLink);
	tt:Show();

	local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4,
    Suffix, Unique, LinkLvl, Name = string.find(itemLink,
    "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
	
	
	local itemLevel = 0;
	for i = 2, tt:NumLines() do
		local text = _G[ tt:GetName() .."TextLeft"..i]:GetText();
		
		if(text and text ~= "") then
			local value = tonumber(text:match(ITEM_LEVEL:gsub( "%%d", "(%%d+)" )));
			if(value) then
				itemLevel = value;
				if (Color ==  "e6cc80")then
					KamiUI.KamiLog(text);
				end
			end
		end
	end
	tt:Hide();
	return itemLevel
end

--needs a delay to make sure all INSPECT_READY has finished calling
local function onUpdate(self,elapsed)
	if (inspecting) then
		if(GetTime() - lastInspectReady > .5) then
		inspecting = false
		ILvlFrame:intializeItemLevelInspection()
		end
	end
end

ILvlFrame:SetScript("OnUpdate", onUpdate)
